//SDL Joystick Test v1.0 <20120510>
//Author: DarkRanger <http://darkranger.no-ip.org/>
//License: GNU General Public License
//Requirment: SDL (http://www.libsdl.org/)

#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>

int main(int argc, char *argv[])
{
 int quit = 0, i = 0;
 int32_t time_save = 0;

 int axis_x, axis_y = 0;
 //axis_x 1: Left
 //axis_x 2: Right
 //axis_y 1: Up
 //axis_y 2: Down
 //axis_x 1 + axis_y 1 = Left/Up
 //axis_x 1 + axis_y 2 = Left/Down
 //axis_y 1 + axis_x 2 = Right/Up
 //axis_y 2 + axis_x 2 = Right/Down

 SDL_Event event;
 SDL_Joystick *joystick;

 if (SDL_Init( SDL_INIT_VIDEO|SDL_INIT_JOYSTICK ) < 0)
   {
     fprintf(stderr, "Couldn't initialize SDL: %s\n", SDL_GetError());
     exit(1);
   }
 else
  {
     time_save = SDL_GetTicks();
  }


 if (SDL_NumJoysticks() > 0)
    {
     SDL_JoystickEventState(SDL_ENABLE);

     printf("Use Ctrl+C to exit.\n");
     printf("%i joystick(s) were found:\n", SDL_NumJoysticks() );

       for( i=0; i < SDL_NumJoysticks(); i++ ) 
          {

            printf("[ %s ]\n", SDL_JoystickName(i));
            joystick = SDL_JoystickOpen(i);
          }

       while( quit == 0 )
          {
            while( SDL_PollEvent(&event))
               {      
               switch (event.type)
                   {
                    case SDL_JOYBUTTONDOWN:  
                         printf("Button = %d\n", event.jbutton.button);
                    break;

                    case SDL_JOYHATMOTION:
                         switch (event.jhat.value)
                              {
                             case SDL_HAT_LEFT:
                                  printf("Hat = Left\n");
                             break;

                             case SDL_HAT_RIGHT:
                                  printf("Hat = Right\n");
                             break;

                             case SDL_HAT_UP:
                                  printf("Hat = Up\n");
                             break;

                             case SDL_HAT_DOWN:
                                  printf("Hat = Down\n");
                             break;

                             case SDL_HAT_LEFTUP:
                                  printf("Hat = Left/Up\n");
                             break;

                             case SDL_HAT_LEFTDOWN:
                                  printf("Hat = Left/Down\n");
                             break;

                             case SDL_HAT_RIGHTUP:
                                  printf("Hat = Right/Up\n");
                             break;

                             case SDL_HAT_RIGHTDOWN:
                                  printf("Hat = Right/Down\n");
                             break;
                               }
                     break;

                     case SDL_JOYAXISMOTION:

                          if ( ( event.jaxis.value < -32500 ) || (event.jaxis.value > 32500 ) ) 
                               {
                             switch (event.jaxis.axis)
                                   {
                                 case 0:
                                      if ( (SDL_GetTicks() - time_save) > 400 && axis_y == 0 )
                                             {
                                          SDL_Delay(200);
                                          time_save = SDL_GetTicks();
                                          axis_x = 0 ;

                                               if (event.jaxis.value < -32500)
                                                       {
                                                   printf("Axis = Left\n");
                                                       }
                                               else
                                                       {
                                                   printf("Axis = Right\n");
                                                       }                                            
                                             }
                                      else if ( (SDL_GetTicks() - time_save) < 1000 )
                                             {
                                           if ( axis_y == 0 )
                                                   {
                                               if (event.jaxis.value < -32500)
                                                       {
                                                   axis_x = 1;
                                                       }
                                               else
                                                       {
                                                   axis_x = 2;
                                                       }
                                                   }
                                           else
                                                   {
                                               if (event.jaxis.value < -32500)
                                                       {
                                                   if ( axis_y == 1 )
                                                           {
                                                        printf("Axis = Left/Up\n");
                                                           }
                                                   else
                                                           {
                                                        printf("Axis = Left/Down\n");
                                                           }
                                                       }
                                               else
                                                       {
                                                   if ( axis_y == 1 )
                                                           {
                                                        printf("Axis = Right/Up\n");
                                                           }
                                                   else
                                                           {
                                                        printf("Axis = Right/Down\n");
                                                           }
                                                       }
                                                axis_y = 0; 
                                                axis_x = 0; 
                                                time_save = SDL_GetTicks();
                                                   }
                                             }
                                      else
                                             {
                                           axis_y = 0; 
                                           axis_x = 0;                
                                             }
                                 break;

                                 case 1:
                                      if ( (SDL_GetTicks() - time_save) > 400 && axis_x == 0 )
                                             {
                                          SDL_Delay(200);
                                          time_save = SDL_GetTicks();
                                          axis_y = 0 ;
        
                                               if (event.jaxis.value < -32500)
                                                       {
                                                   printf("Axis = Up\n");
                                                       }
                                               else
                                                       {
                                                   printf("Axis = Down\n");
                                                       }
                                             }
                                     else if ( (SDL_GetTicks() - time_save) < 1000 )
                                             {
                                           if ( axis_x == 0 )
                                                   {
                                               if (event.jaxis.value < -32500)
                                                       {
                                                   axis_y = 1;
                                                       }
                                               else
                                                       {
                                                   axis_y = 2;
                                                       }
                                                   }
                                           else
                                                   {
                                               if (event.jaxis.value < -32500)
                                                       {
                                                   if ( axis_x == 1 )
                                                           {
                                                        printf("Axis = Left/Up\n");
                                                           }
                                                   else
                                                           {
                                                        printf("Axis = Right/Up\n");
                                                           }
                                                       }
                                               else
                                                       {
                                                   if ( axis_x == 1 )
                                                           {
                                                        printf("Axis = Left/Down\n");
                                                           }
                                                   else
                                                           {
                                                        printf("Axis = Right/Down\n");
                                                           }
                                                       }
                                                axis_y = 0; 
                                                axis_x = 0; 
                                                time_save = SDL_GetTicks();             
                                                   }
                                             }
                                      else
                                             {
                                           axis_y = 0; 
                                           axis_x = 0;                
                                             }
                                 break;
                                   }
                               }

                     break;

                     case SDL_QUIT:
                          quit = 1;
                     break;
                   }  
               }
          }
    }
 else
   {
     printf("Can't find any joysticks, aborted.\n");   
   } 
  
 atexit( SDL_Quit );
 return 0;
}
